<template>
  <v-row class="mt-2">
    <v-col>
      <v-card>
        <v-data-table
          :headers="headers"
          :items="resMasterData"
          :items-per-page="5"
          class="elevation-1"
        >
          <template v-slot:item.action="{ item }">
            <v-btn icon @click="goToEdit(item.id)" color="primary"
              ><v-icon>mdi-pencil</v-icon></v-btn
            >
            <v-btn icon @click="submitDelete(item.id)" color="#e21717"
              ><v-icon>mdi-delete</v-icon></v-btn
            >
          </template>
        </v-data-table>
        <v-fab-transition fluid style="z-index: 100">
          <v-btn fab fixed color="#008ef8" @click="goToAdd()" bottom right>
            <span class="text-white-sm">
              <v-icon>mdi-plus</v-icon>
            </span>
          </v-btn>
        </v-fab-transition>
      </v-card>
    </v-col>
  </v-row>
</template>

<script>
import { createNamespacedHelpers } from "vuex";
const inventory = createNamespacedHelpers("inventory");

export default {
  name: "TableViewDashboard",
  data() {
    return {
      headers: [
        { text: "Inventory Name", value: "name_product" },
        { text: "Inventory Description", value: "description" },
        { text: "Inventory Quantity", value: "pcs" },
        { text: "", value: "action" }
      ]
    };
  },
  mounted() {
    this.$store.dispatch("inventory/getData");
  },
  computed: {
    ...inventory.mapState(["resMasterData"])
  },
  methods: {
    goToEdit(val) {
      this.$router.push("/inventory/edit/" + val);
    },
    goToAdd() {
      this.$router.push("/inventory/add");
    },
    submitDelete(val) {
      this.$store.commit("inventory/SET_IDDATA", val);
      this.$swal
        .fire({
          title: "Delete Data",
          text: "Kamu yakin menghapus inventory ini?",
          icon: "warning",
          showDenyButton: true,
          confirmButtonColor: "#3085d6",
          cancelButtonColor: "#d33",
          confirmButtonText: "Yes, delete it!"
        })
        .then(result => {
          if (result.isConfirmed) {
            this.$store
              .dispatch("inventory/deteleData")
              .then(response => {
                const res = response.data;
                const messagesSuccess = res.status.message;
                if (res.status) {
                  this.$swal
                    .fire("Success!!", messagesSuccess, "success")
                    .then(result => {
                      if (result.isConfirmed) {
                        this.$store.dispatch("inventory/getData");
                      }
                    });
                }
              })
              .catch(error => {
                const messagesError = error.response.data.status.message;
                this.$swal.fire("Error!!", messagesError, "error");
              });
          }
        });
    }
  }
};
</script>
